#!/usr/bin/python3
import os
import sys
import re
import time
from gi.repository import GLib
from pydbus import SystemBus
from pydbus import SessionBus
from pydbus.generic import signal
import subprocess
import importlib,sys
import _thread
importlib.reload(sys)
import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
import threading
import ctypes
import socket
import struct
import inspect
import getpass #日志



def hello_signal_handler():

    print("我接到信号啦！！！")
    getDevices()
    result = os.popen("ifconfig | awk -F'[ :]+' '!NF{if(eth!=\"\"&&ip==\"\")print eth;eth=ip4=\"\"}/^[^ ]/{eth=$1}/inet addr:/{ip=$4}'")
    wangka = result.read()
    for line in wangka.splitlines():
        print(line)
    print(len(wangka.splitlines()))

def writelog(message):
    print("写日志咯")
    fo = open("/var/log/netIsolation.log", "a")
    log_time=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    fo.write( log_time+" [Error] "+message+"\n") 
    fo.close()

def readfile():
    try:
        with open("/etc/net_isolation_dns.conf","r",encoding="utf-8") as f2:
            dns_str=f2.read().replace("\n",",")
        print(dns_str.split(","))
    except:
        print("wenjianbucunzai ")
def sendmysignal():
    print("...")
    
def get_host_name():
    """获取当前用户名"""
    try:
        bus2 =dbus.SystemBus()
        proxy = bus2.get_object("com.kylin.kydevmonit.hedronclient","/kydevmonit/hedronclient")
        username = proxy.get_current_user()
    except:
        username = 'root'
    return  username  

def get_host_time():
    """获取本机时间
    return: time_1
    """
    time_1=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    return time_1

def get_host_ip():
    """
    查询本机ip地址
    :return: ip
    """
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    except Exception:
        return "127.0.0.1"
    return ip

def passlog(message):
    str_1 = "'time':'{}','hostname':'{}','ip':'{}','name':'Net Isolation Control','lv':'Error','message':'{}'".format(get_host_time(), get_host_name(), get_host_ip(),message)
    str_2='{'+str_1+'}'
    try:
        bus2 =SystemBus()
        change = bus2.get("org.log.sys_transmit","/org/log/sys_transmit")
        change.log_transmit(str_2)
    except:
        print(str_2)

def sendmessage(message):
    bus3 = SessionBus()
    notifications = bus3.get('.Notifications')
    notifications.Notify('test', 0,  'network-offline', "断开连接", message, [], {}, 5000)

def getDevices(dbus_service):
#    while(1):
#        sendmessage("开始检测")
        writelog("开始检测")
        ethlist=[]#存放网卡名
        ethip4list=[]#存放ip4地址  /org/freedesktop/NetworkManager/IP4Config/1
        ethsettingslist=[]#存放settings
        ethactive=[]#存放activeconnections  /org/freedesktop/NetworkManager/ActiveConnection/0
        dict1={}
        bus = SystemBus()
        the_object1 = bus.get("org.freedesktop.NetworkManager", "/org/freedesktop/NetworkManager")
        ActCon_1 = the_object1.AllDevices #['/org/freedesktop/NetworkManager/Devices/0', '/org/freedesktop/NetworkManager/Devices/1', '/org/freedesktop/NetworkManager/Devices/2', '/org/freedesktop/NetworkManager/Devices/3']
        print(ActCon_1)
        for a in ActCon_1:
            ethactive = the_object1.ActiveConnections   #/org/freedesktop/NetworkManager/ActiveConnection/0

            the_object2 = bus.get("org.freedesktop.NetworkManager", a)

            ethname = the_object2.Interface #enaftgm1i0
            ethlist.append(ethname)

            ip4con = the_object2.Ip4Config  #/org/freedesktop/NetworkManager/IP4Config/1
            ethip4list.append(ip4con)
            
            settings =the_object2.AvailableConnections  #['/org/freedesktop/NetworkManager/Settings/4']
            ethsettingslist.append(settings)
            
        for i in ethlist:#show 网卡名
            print("网卡名为："+i)
            dict1[i]="默认"

        for i in ActCon_1:
            temp_3=bus.get("org.freedesktop.NetworkManager",i)
            temp_4=temp_3.DeviceType
            temp_5=temp_3.Interface
            if(temp_4==23):
                dict1[temp_5]="vpn"
        

        #----------v10
        for i in ethlist:
            if("ppp"in i):
                print("网卡"+i+"是vpn网卡")
                dict1[i]="vpn"
        #------------



        # for i in ethactive:   #遍历判断vpn网卡
        #     print(i)
        #     the_object3 = bus.get("org.freedesktop.NetworkManager", i)
        #     print(the_object3.Vpn)

        #     the_object4 = bus.get("org.freedesktop.NetworkManager",the_object3.Connection)
        #     xx = the_object4.GetSettings()

        #     if(the_object3.Vpn==False):
        #         print(xx["ipv4"]["dns"])
        #         print("不是vpn网卡")
        #     else:
        #         dict1[xx["connection"]["interface-name"]]="vpn"

        try:
            with open("/etc/net_isolation_dns.conf","r",encoding="utf-8") as f2:
                dns=f2.read().replace("\n",",")
                dns_list=dns.split(",")
        except:
            dns_list=[]

        #########判断DNS  -v10.1
        # the_object5=bus.get("org.freedesktop.NetworkManager","/org/freedesktop/NetworkManager/DnsManager")
        # dns_info=the_object5.Configuration
        # for i in dns_info:
        #     print(i["nameservers"])
        #     bool_1=0
        #     for j in i["nameservers"]:
        #         if(j in dns_list):		#DNS是否为。。地址
        #             print(i["interface"])
        #             bool_1=1   #在
        #     if(bool_1 ==0):  #不在 标记 外
        #         print("这个网卡不在哦"+i["interface"])
        #         if(dict1[i["interface"]]!="vpn"):
        #             dict1[i["interface"]]="wai"
        #     if(bool_1 ==1):  #在
        #         print("这个网卡在哦"+i["interface"])

        #############
        #########判断DNS  -v10
        for a in ActCon_1:
            ethactive = the_object1.ActiveConnections   #/org/freedesktop/NetworkManager/ActiveConnection/0
            the_object2 = bus.get("org.freedesktop.NetworkManager", a)
            ethname = the_object2.Interface #enaftgm1i0
            ip4con = the_object2.Ip4Config  #/org/freedesktop/NetworkManager/IP4Config/1
            print("网卡名为"+ethname)
            try:
                the_object3 = bus.get("org.freedesktop.NetworkManager",ip4con)
                dns_1=the_object3.Nameservers
                print(dns_1)
                if(dns_1!=""):
                    dns_2=socket.inet_ntoa(struct.pack('!I', dns_1[0]))
                    abc=dns_2.split(".")
                    abc.reverse()
                    dns_final=abc[0]+'.'+abc[1]+'.'+abc[2]+'.'+abc[3]     
            except:
                continue
                

            print(dns_final)
            bool_1=0
            if(dns_final in dns_list):
                print(ethname)
                bool_1=1  #在
            if(bool_1 == 0): #不在  标记外
                print("这个网卡不在哦"+ethname)
                if(dict1[ethname]!="vpn"):
                    dict1[ethname]="wai"
            if(bool_1 == 1): #在
                print("这个网卡在哦"+ethname)


        #############
        #######
        print(dict1)

        try:
            with open("/etc/net_isolation_ip.conf","r",encoding="utf-8") as f3:
                in_ip=f3.read().replace("\n",",")
                in_ip_list=in_ip.split(",")
        except:
            in_ip_list=[]
        print(in_ip_list)
        print(dns_list)
#####################################多线程ping
        dict_ip={}
        def f3_ping_netcard(c):
            nonlocal in_ip_list
            nonlocal dict_ip
            for j in in_ip_list:
                if j=="":
                    continue
                t4=threading.Thread(target=f3_ping_ip,args=(c,j,))
                t4.setDaemon(True)
                t4.start()
                print(dict_ip)
                
        def f3_ping_ip(a,bb):
            nonlocal dict1
            nonlocal dict_ip
            print("网卡为:"+a+"------地址为:"+bb)
            ping_res=os.system("ping "+bb+" -c 1 -w 5 -I "+a)
            if ping_res==0 : #能ping通
                dict_ip[bb]="1"
                dict1[a]="nei"
            else:           #不能ping通
                dict_ip[bb]="0"

        for i in ethlist:
            if(dict1[i]=="默认"):
                t3=threading.Thread(target=f3_ping_netcard,args=(i,))
                t3.setDaemon(True)
                t3.start()
            else:
                continue 
        time.sleep(10)  
        print(in_ip_list)
        print("+++++++++++++++++++++++++++++++++++")
        for i in ethlist:
            if(dict1[i]=="默认"):
                dict1[i]="wai"
            else:
                continue  


        the_object7 = bus.get("org.freedesktop.NetworkManager", "/org/freedesktop/NetworkManager")
        ethactive=the_object7.ActiveConnections
        print(ethactive)
        print("=========")
        eth_arr=[]
        for i in ethactive:
            the_object9 =bus.get("org.freedesktop.NetworkManager", i)
            dev_path=the_object9.Devices
            for j in dev_path:
                the_object8=bus.get("org.freedesktop.NetworkManager",j)
                eth_arr.append(the_object8.Interface)
        dict1['lo']="本地"
        print(eth_arr)
        print(dict1)
        for i in ethactive:
            state=bus.get("org.freedesktop.NetworkManager",i).State
            print("*******************")
            print(state)
            if(state!=2):
                writelog("当前判断的网络未处于真正连接状态")
                break
            the_object10=bus.get("org.freedesktop.NetworkManager", i)
            dev2_path=the_object10.Devices
            for j in dev2_path:
                dev_name=bus.get("org.freedesktop.NetworkManager",j).Interface
                for ii in dict1:
                    if(dict1[ii]=="vpn" or dict1[ii]=="nei"):
                        #有内网 断开网卡名为dev_name的网卡
                        try:
                            if(os.path.isfile("/etc/net_isolation.conf")==True):
                                if(dev_name in eth_arr and dict1[dev_name]=="wai"):
                                    temp_6=bus.get("org.freedesktop.NetworkManager",j)
                                    temp_6.Disconnect()
                                    print("-------"+dev_name)
                                    dbus_service.OnEmitSignal_netcard()
                                    writelog("检测到内外网卡同时连接，断开网卡"+dev_name+"的网络连接")
                                    #sendmessage("检测到内外网卡同时使用,断开外网网卡网络连接")
                                    #os.system("notify-send -i network-offline '断开连接' '由于内外网卡同时连接网络，断开外网连接!'")#提示用户
                                    passlog("检测到内外网卡同时连接，断开网卡"+dev_name+"的网络连接")
                        except:
                                print("------error"+dev_name+"该连接已断开")

        print("over")
#        sendmessage("检测结束")
        writelog("检测结束")


def test1(dbus_service):
    while(1):
        dbus_service.OnEmitSignal()
        time.sleep(2)


# class Checkinoutnet():

#     """
#     <node>
#         <interface name='com.kylin.checkinoutnet'>
#         	<signal name='OnEmitSignal_2'>\n"
#             </signal>"
#         </interface>
#     </node>
#     """
#     OnEmitSignal_2 =signal()


class Checkinoutnet(dbus.service.Object):

    def __init__(self):
        # 初始化dbus进程
        bus_name = dbus.service.BusName('com.kylin.checkinoutnet', bus=dbus.SystemBus())
        self.obj = dbus.service.Object.__init__(self, bus_name, '/com/kylin/checkinoutnet')

    @dbus.service.signal(dbus_interface='com.kylin.checkinoutnet')
    def OnEmitSignal_netcard(self):
        print("sent signal over")

    # @dbus.service.method(dbus_interface='com.kylin.checkinoutnet')
    # def send_single(self):
    #     self.OnEmitSignal()
    #     return 




def _async_raise(tid, exctype):
    """raises the exception, performs cleanup if needed"""
    tid = ctypes.c_long(tid)
    if not inspect.isclass(exctype):
        exctype = type(exctype)
    res = ctypes.pythonapi.PyThreadState_SetAsyncExc(tid, ctypes.py_object(exctype))
    if res == 0:
        raise ValueError("invalid thread id")
    elif res != 1:
        # """if it returns a number greater than one, you're in trouble,
        # and you should call it again with exc=NULL to revert the effect"""
        ctypes.pythonapi.PyThreadState_SetAsyncExc(tid, None)
        raise SystemError("PyThreadState_SetAsyncExc failed")
 
 
def stop_thread(thread):
    _async_raise(thread.ident, SystemExit)



def getDevices22(dbus_service):
    print("开始啦！！")
    while(1):
        print("-----")
        time.sleep(3)


def f1(dbus_service):
    while(1):
        ab=threading.Thread(target=getDevices,args=(dbus_service,))
        ab.setDaemon(True)
        ab.start()
        sl_time=30
        try:
            with open('/etc/net_isolation_time.conf') as file_obj:
                contents=file_obj.read()
                sl_time=(int(contents))
                print(sl_time)
        except:
            print("文件不存在")
        time.sleep(sl_time)







DBusGMainLoop(set_as_default=True)
dbus_service = Checkinoutnet()
bus = dbus.SystemBus()
t=threading.Thread(target=f1,args=(dbus_service,))
t.setDaemon(True)
t.start()
mainloop = GLib.MainLoop()
mainloop.run()



